(define (domain rpg)

    (:requirements :strips :typing :negative-preconditions :disjunctive-preconditions)

    (:types
        room
    )

    (:predicates
        (at ?x - room)
        (monster_in ?x - room)
        (trap_in ?x - room)
        (sword_in ?x - room)
        (destroyed ?x - room)
        (connected ?from - room ?to - room)
        (handempty)
    )

    (:action move
        :parameters (?room1 - room ?room2 - room)
        :precondition (and
            (connected ?room1 ?room2)
            (at ?room1)
            (not (destroyed ?room2))
            (not (trap_in ?room1))
            (or
                (not (handempty))
                (not (monster_in ?room2))
            )
        )
        
        :effect (and
            (not (at ?room1))
            (destroyed ?room1)
            (at ?room2)
        )
    )

    (:action pickup
        :parameters (?room - room)
        :precondition (and
            (handempty)
            (sword_in ?room)
            (at ?room)
        )
        
        :effect (and
            (not (sword_in ?room))
            (not (handempty))
        )
    )

    (:action destroy
        :parameters (?room - room)
        :precondition (and
            (at ?room)
            (not (trap_in ?room))
            (not (monster_in ?room))
            (not (handempty))
        )
        
        :effect (and
            (handempty)
        )
    )

    (:action disarm
        :parameters (?room - room)
        :precondition (and
            (handempty)
            (at ?room)
            (trap_in ?room)
        )
        
        :effect (and
            (not (trap_in ?room))
        )
    )
)